<script type="text/javascript">
    RED.nodes.registerType('xkeys_button',{
        category: 'Xkeys',
        color: '#5dc8f4',
        defaults: {
            newname: {value:"X-keys Button"},
            name: {value:""},
			device: {value:""},
			productid: {value:"",
				validate:function(v){
					return v==""?true:(999 < parseInt(v) && parseInt(v) < 10000);
				}
			},
			pid_list: {value:"[]"},
			unit_id: {value:"",
				validate:function(v){
					return v==""?true:(-1 < parseInt(v) && parseInt(v) < 256);
				}
			},
			duplicate_id: {value:"",
				validate:function(v){
					return v==""?true:(-1 < parseInt(v) && parseInt(v) < 256);
				}
			},
			button_id: {value:"",
				validate:function(v){
					return v==""?true:(-1 < parseInt(v));
				}
			},
			presstype: {value:"all"},
        },
        inputs:0,
        outputs:1,
        icon: "X-keysXicon.png",
        label: function() {
            return this.name||this.newname||"X-keys Button";
        },
		labelStyle: function () {
			return this.newname?"node_label_italic":"";
		},
		paletteLabel: "xk button",
		oneditprepare: function() {
			var press_options = [{label:"All",value:"all"}, {label:"Down",value:"down"}, {label:"Up",value:"up"}];
			var device_options = [];
			device_options.push({ value: "Any X-keys", label: "Press Deploy button to see device list"});
			$.getJSON('xkeys_button/products', function(product_data) {
				var devs = Object.keys(product_data);
				if (devs.length !== 0) {
					for (var d in devs) {
						if (devs.hasOwnProperty(d)) {
							device_options.push({ label: product_data[devs[d]].name, value:  devs[d]});
						}
					}
				}
				if (device_options.length > 1) {
					// Replace suggestion to deploy flow
					device_options[0] = { value: "Any X-keys", label: "Any X-keys"};
				}
				$("#node-input-device").typedInput({
					types: [{
						value: "device",
						options: device_options
					}]
				});
				if ($("#node-input-device").val() == "Any X-keys") {
					$("#node-input-productid").attr("placeholder", "Any");
				} else {
					$("#node-input-productid").attr("placeholder", "Auto");
				}
				$("#node-input-productid").on('change', function(ev, evtype, value) {
					// If productid is deleted (becomes Auto),
					// reset pid_list to whatever device is currently selected
					if ($("#node-input-productid").val().length == 0) {
						//var current_device = $("#node-input-device").val();
						set_pid_list($("#node-input-device").val());
					}
				});
				$("#node-input-presstype").typedInput({
					types: [{
						value: "presstype",
						options: press_options
					}]
				});
				$("#node-input-device").on('change', function(ev, evtype, value) {
					set_pid_list(value);
				});
				/*
				*	Setup pid_list for a given device
				*/
				function set_pid_list (devicenam) {
					if (devs.includes(devicenam)) {
						// Collect the possible pid_list entries
						var hidDevs = [];
						product_data[devicenam].hidDevices.forEach(function(product_id) {
							hidDevs.push(product_id[0]);
						})
						// Save the pid_list for later matching with attached devices
						$("#node-input-pid_list").val(JSON.stringify(hidDevs));
						$("#node-input-productid").attr("placeholder", "Auto");
						$("#node-input-productid").val("");
					} else if (devicenam == "Any X-keys") {
						$("#node-input-pid_list").val(JSON.stringify([]));
						$("#node-input-productid").attr("placeholder", "Any");
						$("#node-input-productid").val("");
					} else {
						console.log("Unknown device selected");
					}
				};	// End of set_pid_list(devicenam)
			})
		},
		oneditsave: function () {
			// Construct label based on configured options
			this.newname = $("#node-input-device").typedInput('value');
			var duplicate_id = $("#node-input-duplicate_id").val();
			var unit_id = $("#node-input-unit_id").val();
			var button_id = $("#node-input-button_id").val();
			if (unit_id) {
				this.newname += " (" + unit_id + ") Button";
			} else {
				this.newname += " Button";
			}
			if (button_id) {
				this.newname += " " + button_id;
			}
			// Handle case when productid was specified
			var productid = $("#node-input-productid").val();
			if (productid) {
				var pid_list = [];
				pid_list.push(parseInt(productid));
				$("#node-input-pid_list").val(JSON.stringify(pid_list));
			}
		}
    });
</script>

<script type="text/html" data-template-name="xkeys_button">
	<div class="form-row">
		<label for="node-input-device"><i class="fa fa-keyboard-o"></i> Device</label>
		<input type="text" id="node-input-device" placeholder="Device">
	</div>
	<div class="form-row">
		<label for="node-input-productid"><i class="fa fa-info"></i> Product ID</label>
		<input type="text" id="node-input-productid" placeholder="Any">
	</div>
	<div class="form-row">
		<label for="node-input-unit_id"><i class="fa fa-info-circle"></i> Unit ID</label>
		<input type="text" id="node-input-unit_id" placeholder="Any">
	</div>
	<div class="form-row">
		<label for="node-input-duplicate_id"><i class="fa fa-list-ol"></i> Duplicate ID</label>
		<input type="text" id="node-input-duplicate_id" placeholder="Any">
	</div>
	<div class="form-row">
		<label for="node-input-button_id"><i class="fa fa-square-o"></i> Button #</label>
		<input type="text" id="node-input-button_id" placeholder="All">
	</div>
	<div class="form-row">
		<label for="node-input-presstype"><i class="fa fa-hand-o-down"></i> Action</label>
		<input type="text" id="node-input-presstype" placeholder="All">
	</div>
    <div class="form-row">
        <label for="node-input-name"><i class="fa fa-tag"></i> Label</label>
        <input type="text" id="node-input-name" placeholder="Auto">
    </div>
    <div class="form-row">
        <input type="hidden" id="node-input-pid_list">
    </div>
</script>


<script type="text/html" data-help-name="xkeys_button">

<p>X-keys input node, sends button or switch events from any or selected attached X-keys. Generates a <code>msg.payload.button_id </code> from the button pressed, and <code>msg.payload.action</code> with up or down depending on the new state of the button. </p>

 <h3>Properties</h3>
<p>By default this node will send events for any button on any X-keys connected by the USB. By setting these properties the node will only send events matching the desired criteria.</p>
 <li><b>Device:</b> Select from the list the name of specific source X-keys </li>
<li><b>Product ID:</b> A specific PID can be set, usually the device name is sufficient and this can be left to the default.</li>

<li><b>Unit ID:</b> A specific Unit can be selected, this is useful if there are 2 indentical X-keys. Each one can have a different UID if set using the xk Set Unit ID node. </li>
<li><b>Button #:</b> If events from only one specific button are desired then this property can be set. If left to "All" then a switch node can be used to create cases for each button. </li>
<li><b>Action:</b> Select "Up" or "Down" from list. By default a down and up event will be triggered by a button as it  is pressed and released. Often, only the down is of interest.</li>

 

 <h3>Outputs</h3>

     <p><code>msg.payload</code>  An object that contains the compete information from the button event</p>
         <li><code>msg.payload.device</code> is an abbreviated name of the source device e.g. XK12JOG, which represents the XK-12 Jog & Shuttle device
          </li>
         <li><code>msg.payload.product_id</code> is the Product ID of the source device e.g. 1062 for the XK-12 Jog & Shuttle device
         </li>
 <li><code>msg.payload.unit_id</code> is the Unit ID of the source device, typically 0 from the factory but assignable 0-255 using the xk Set Unit ID node
         </li>
<li><code>msg.payload.button_id</code> is the button number which caused the event
         </li>
<li><code>msg.payload.action</code> is the type of event that occurred. Button events may be either "down" or "up" types
         </li>
     

<h3>Details</h3>
    <p>This node is used to get button or switch closure events from a connected X-keys. Some X-keys have additional features, such as a jog wheel. This node would be used to get the button events, while the analog events would be accessed with the xk jog shuttle node, for example. </p>
    <p>Several filters can be set in the node’s properties to make the node respond to specific X-keys and/or specific buttons and actions. Alternatively, the payload may be passed on to a switch node to branch the flow for each button or device.  </p>
    <p>This node requires the X-keys Server to be installed. X-keys server requires an MQTT broker, which also must be installed.</p>
  

<h3>References</h3>
    <ul>
        <li><a href="https://www.xkeys.com">For a full description of all X-keys products</a></li>
        <li><a href="https://gitlab.com/chris.willing/xkeys-server">X-keys server installation</a></li>
    </ul>

</script>
